<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px" @submit.native.prevent>
      <el-form-item label="类别" prop="typeId">
        <template>
          <el-select v-model="queryParams.typeId" filterable placeholder="请选择">
            <el-option
              v-for="item in trafficTypeList"
              :key="item.typeId"
              :label="item.typeName"
              :value="item.typeId">
            </el-option>
          </el-select>
        </template>
      </el-form-item>
      <el-form-item label="名字" prop="trafficName">
        <el-input
          v-model="queryParams.trafficName"
          placeholder="请输入名字"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['info:trafficInfo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['info:trafficInfo:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['info:trafficInfo:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['info:trafficInfo:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="trafficInfoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="交通id" align="center" prop="trafficId" />
      <el-table-column label="类型" align="center">
        <template slot-scope="scope">
          {{ getTrafficTypeName(scope.row.typeId) }}
        </template>
      </el-table-column>
      <el-table-column label="名字" align="center" prop="trafficName" />
      <el-table-column label="数量" align="center" prop="amount" />
      <el-table-column label="颜色" prop="colour">
        <template slot-scope="scope">
          <div :style="{ backgroundColor: scope.row.colour, width: '40px', height: '30px', borderRadius: '50%'}"></div>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="140">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['info:trafficInfo:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['info:trafficInfo:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改交通对象对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="类别" prop="typeId">
          <template>
            <el-select v-model="form.typeId" filterable placeholder="请选择">
              <el-option
                v-for="item in trafficTypeList"
                :key="item.typeId"
                :label="item.typeName"
                :value="item.typeId">
              </el-option>
            </el-select>
          </template>
        </el-form-item>
        <el-form-item label="名字" prop="trafficName">
          <el-input v-model="form.trafficName" placeholder="请输入名字" />
        </el-form-item>
        <el-form-item label="数量" prop="amount">
          <el-input-number v-model="form.amount" controls-position="right"   :min="0" placeholder="请输入数量" />
        </el-form-item>

        <el-form-item label="备注" prop="memo">
          <el-input v-model="form.memo" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="颜色">
          <el-color-picker v-model="form.colour"></el-color-picker>
        </el-form-item>
        <el-form-item label="坐标" prop="location">
          <el-input v-model="form.location" @focus="openditu">
            {{ form.location}}
          </el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>


    <el-dialog title="地图" :visible.sync="dialogVisible" width="80%">
      <div id='mainMap'>
        <div id="mapDiv" style="width:100%; height:700px">
        </div>
      </div>
      <input type="button" value="清除" @click='clearmian()' />
      <input type="button" value="划线工具" @click='openPolylineTool()' />
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click='tijiao'>确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import { listTrafficInfo, getTrafficInfo, delTrafficInfo, addTrafficInfo, updateTrafficInfo, exportTrafficInfo } from "@/api/info/trafficInfo";
import { listTrafficType, getTrafficType } from "@/api/type/trafficType";
export default {
  name: "TrafficInfo",
  data() {
    return {
      polylineTool: null,
      handler: null,
      geoJson: {
        type: "Polyline",
        coordinates: [],
      },
      map: null,
      dialogVisible: false,
      trafficTypeList: [],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 交通对象表格数据
      trafficInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        typeId: null,
        trafficName: null,
      },
      queryTypeParams: {
        pageNum: 1,
        pageSize: 9999,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        trafficId: [
          { required: true, message: "交通id不能为空", trigger: "blur" }
        ],
        typeId: [
          { required: true, message: "类别不能为空", trigger: "change" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getTrafficTypes();
  },
  methods: {

    // 销毁天地图
    destructionTMap ()  {
      if (this.map) {
        this.map = null;
        this.geoJson.coordinates= []
        // 直接将节点给删掉
        console.log('1qsad');

        const parentEl = document.getElementById('mainMap');
        const cahildrenEl = document.getElementById('mapDiv');
        if(cahildrenEl) parentEl.removeChild(cahildrenEl);
        // 然后再手动将节点加进来
        const newCahildrenEl = document.createElement("div");
        newCahildrenEl.id = 'mapDiv'
        newCahildrenEl.style = 'height: 700px;width: 100%;'
        parentEl.appendChild(newCahildrenEl)
      }
    },

    tijiao() {
      console.log('多边形数据:', this.form.location);

      if (this.geoJson.coordinates.length > 0) {
        this.form.location = JSON.stringify(this.geoJson)
      }

      this.destructionTMap()
      this.dialogVisible = false;

    },

    openPolylineTool(){
      console.log(this.form.location);
      if (JSON.parse(this.form.location).coordinateslength > 0 || this.geoJson.coordinates.length > 0 ) {
        this.$notify({
          title: '警告',
          message: '请先清空地图',
          type: 'warning'
        });
        return
      }
      // if (this.handler) this.handler.close();
      this.handler = new T.PolylineTool(this.map, {
        color: "red", weight: 3.5, opacity: 0.8, fillColor: "red", fillOpacity: 0.5
      });
      this.handler.open();
      this.handler.on("draw", (yu) => {
        console.log("参数？？99", yu.currentLnglats);
        let drawData = yu.currentLnglats.map((item) => {
          return [item.lng, item.lat];
        });
        this.geoJson.coordinates= drawData;
        console.log("区域之后处理数据", this.geoJson.coordinates);

      });
    },

    showPolyLine() {
      var points = [];
      JSON.parse(this.form.location).coordinates.map((item) => {
        points.push(new T.LngLat(item[0], item[1]));
      })
      console.log('kanknak2', points);
      //创建面对象
      var polyline = new T.Polyline(points, {
        color: "red", weight: 3.5, opacity: 0.8, fillColor: "red", fillOpacity: 0.5
      });
      //向地图上添加面
      this.map.addOverLay(polyline);;
    },

    clearmian(){
      this.geoJson.coordinates = []
      this.$set(this.form, 'location', JSON.stringify(this.geoJson))
      this.map.clearOverLays()

    },

    openditu(){
      if (this.form.location == null){
        this.$set(this.form, 'location', JSON.stringify(this.geoJson))
      }
      this.dialogVisible = true;
      this.$nextTick(() => {
        const T = window.T;
        const zoom = 12;
        this.map = new T.Map('mapDiv');
        this.map.centerAndZoom(new T.LngLat(103.96, 30.66), zoom);
        this.showPolyLine();
      });


    },

    getTrafficTypeName(typeId) {
      const type = this.trafficTypeList.find(b => b.typeId === typeId);
      return type ? type.typeName : '未知';
    },

    getTrafficTypes() {
      listTrafficType(this.queryTypeParams).then(response => {
        this.trafficTypeList = response.data.list;
      });
    },
    /** 查询交通对象列表 */
    getList() {
      this.loading = true;
      listTrafficInfo(this.queryParams).then(response => {
        this.trafficInfoList = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        trafficId: null,
        typeId: null,
        trafficName: null,
        amount: null,
        memo: null,
        location: null,
        colour: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.trafficId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加交通对象";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const trafficId = row.trafficId || this.ids
      getTrafficInfo(trafficId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改交通对象";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.location=JSON.parse(this.form.location)
          if (this.form.trafficId != null) {
            updateTrafficInfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTrafficInfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const trafficIds = row.trafficId || this.ids;
      this.$modal.confirm('是否确认删除交通对象编号为"' + trafficIds + '"的数据项？').then(function() {
        return delTrafficInfo(trafficIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有交通对象数据项？').then(() => {
        this.exportLoading = true;
        return exportTrafficInfo(queryParams);
      }).then(response => {
        this.$download.name(response.msg);
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
